# (Explorer Workshop)
# Copyright: 2024 Bradan Lane STUDIO
#
# Open Source License: MIT

'''
This Python program is a sample from the 'Python' workshop

Implementation Notes
--------------------
**Hardware:**
    * computer

**Software and Dependencies:**
    * Python 3.x
    * Thonny 4.x IDE

**Open Source Repository:**
    * GitLab: https://gitlab.com/bradanlane/exp_tutorial
    
'''

def show_file_contents(filename: str) -> None:
    finished: bool = False
    line: str

    try:
        data_file = open(filename, "r")
    except Exception as e:
        print("error opening file", e)
        finished = True # no file to process

    # the use of 'While True:' creates an infinite loop where code will run forever ... or until an error occurs :-)
    while not finished:
        line = data_file.readline()
        if not line:
            finished = True
            data_file.close()
        else:
            line = line.strip("\n")
            print(line)
    # end of show_file_contents()
    


filename: str = "data/friends.txt"

print("Original File Contents:")
show_file_contents(filename)
print()

    
# create a file add a string
friend: str = input("Enter the nickname of a friend: ")

try:
    data_file = open(filename, "a") # w=write, a=append
    if len(friend) > 0:
        data_file.write("\n" + friend)
    data_file.close()
    print("Updated File Contents:")
    show_file_contents(filename)
except Exception as e:
    print("error adding '{friend}' to file", e)
